> For the complete documentation index, see [llms.txt](https://docs.dcaf.so/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.dcaf.so/products/drip/programming-model/vault.md).

# Vault

The `Vault` is the main account for a token pair and granularity. The `Vault` account is a PDA composed of the following seeds:

```rust
seeds = [
    b"drip-v1".as_ref(),
    token_a_mint.key().as_ref(),
    token_b_mint.key().as_ref(),
    vault_proto_config.key().as_ref(),
],
```

The `Vault` combined with the `Vault Period` is responsible for making sure that user funds are kept track of correctly on deposits and withdraws. The `Vault` also performs the the `Drips` in every period.

```rust
pub struct Vault {
    // Account relations
    pub proto_config: Pubkey,                                   // 32
    pub token_a_mint: Pubkey,                                   // 32
    pub token_b_mint: Pubkey,                                   // 32
    pub token_a_account: Pubkey,                                // 32
    pub token_b_account: Pubkey,                                // 32
    pub treasury_token_b_account: Pubkey,                       // 32
    pub whitelisted_swaps: [Pubkey; VAULT_SWAP_WHITELIST_SIZE], // 32*5

    // Data
    // 1 to N
    pub last_drip_period: u64,          // 8
    pub drip_amount: u64,               // 8
    pub drip_activation_timestamp: i64, // 8
    pub bump: u8,                       // 1
    pub limit_swaps: bool,              // 1
    pub max_slippage_bps: u16,          // 2
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.dcaf.so/products/drip/programming-model/vault.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
